#include <stdio.h>
#include <unistd.h>
#include "misc.h"

add_opt(opt_p, "p", "port",         OPT_ULONG,      (opt_ulong_t)80,     0);
/* number of connections */
add_opt(opt_n, "n", "n-conns",      OPT_ULONG,      (opt_ulong_t)1,      0);
/* milliseconds to sleep between connections */
add_opt(opt_N, "N", "conns-ms",     OPT_ULONG,      (opt_ulong_t)250,    0);
/* milliseconds to sleep between transfers */
add_opt(opt_s, "s", "sleep-ms",     OPT_ULONG,      (opt_ulong_t)0,      0);
/* transfer x segments in between sleeps */
add_opt(opt_x, "x", "xfer-seg",     OPT_ULONG,      (opt_ulong_t)8192,   0);
add_opt(opt_o, "o", "output-file",  OPT_STRING,     (opt_string_t)0,     0);
/* list of commands: one entry per line */
add_opt(opt_S, "S", "string-cmd",   OPT_STRINGLIST, (opt_stringlist_t)0, 0);
/* use a test file for starting/stopping tests */
add_opt(opt_t, "t", "test-file",    OPT_STRING,     (opt_string_t)0,     0);
/* milliseconds to sleep between file tests */
add_opt(opt_T, "T", "test-ms",      OPT_ULONG,      (opt_ulong_t)250,    0);
/* fork n instances */
add_opt(opt_F, "F", "fork-count",   OPT_ULONG,      (opt_ulong_t)0,      0);
/* show time for sends */
add_opt(opt_ts, 0,  "time-send",    OPT_BOOL,       (opt_bool_t)0,       0);
/* show time for receives */
add_opt(opt_tr, 0,  "time-receive", OPT_BOOL,       (opt_bool_t)0,       0);
/* show time for full connections */
add_opt(opt_tf, 0,  "time-full",    OPT_BOOL,       (opt_bool_t)0,       0);
/* show time for all connections */
add_opt(opt_ta, 0,  "time-all",     OPT_BOOL,       (opt_bool_t)0,       0);
/* show debugging information */
add_opt(opt_d, "d", "debug",        OPT_INCREMENT,  (opt_increment_t)0,  0);
/* socket receive buffer (0 == don't modify) */
add_opt(opt_sr, 0,  "socket-rbuf",  OPT_INT,        (opt_int_t)0,        0);
/* socket send buffer (0 == don't modify) */
add_opt(opt_ss, 0,  "socket-sbuf",  OPT_INT,        (opt_int_t)0,        0);

put_opts(options, &opt_p, &opt_n, &opt_N, &opt_s, &opt_x, &opt_o, &opt_S,
		&opt_t, &opt_T, &opt_F, &opt_ts, &opt_tr, &opt_tf, &opt_ta,
		&opt_d, &opt_sr, &opt_ss);

/* global timespecs */
struct timespec time_T;
struct timespec time_s;
struct timespec time_N;

int main(argc, argv)
	int argc;
	char **argv;
{
	char **args;
	int argn;

	gd_setup();
	s_pid[0] = 0; /* sortakludge */

	argn = get_opts_errormatic (&args, argv+1, argc-1, options);

	/* translate these options into timespec structures */
	makenano(&time_T, opt_T.v_opt.opt_ulong);
	makenano(&time_s, opt_s.v_opt.opt_ulong);
	makenano(&time_N, opt_N.v_opt.opt_ulong);

	/* populate sockbuf structure */
	makesockbuf();

	if (argn != 1) die_usage();

	loadtest(args[0]);
	return 0;
}


