#ifndef INC_SLOWGET_MISC_H
#define INC_SLOWGET_MISC_H

#include <sys/time.h>
#include <time.h>
#include "lx_string.h"
#include "gdvars.h"
#include "get_opts.h"

extern void gd_setup (void);
extern void die_usage (void);
extern void die_nomem (void);
extern void die_toobig (char *note);
extern void die_setsockopt (int sd, char *note);
extern void outlog (lx_gd *gd, char *s1, char *s2, char *s3, char *s4, char *s5);
extern void debuglog (int debugn, lx_gd *gd, char *s1, char *s2, char *s3, char *s4, char *s5);
extern void loadtest (char *host); /* ip_addr, rather */
extern int  doconnect (char *host);
extern char send_cmds (lx_gd *gdsd, unsigned long *sbytes);
extern void read_output (lx_gd *gdsd, unsigned long *rbytes);
extern void wait_file (char *fname);
extern void nanosleepy (struct timespec *sleeptime);
extern void fork_procs (unsigned long n);
extern void ptime (char *str, struct timeval *start, struct timeval *end);
extern void pntime (char *str, struct timeval *start, struct timeval *end, unsigned long i);
extern void makenano (struct timespec *ts, unsigned long msecs);
extern void makesockbuf (void);

/* options */
extern opt opt_p;
extern opt opt_n;
extern opt opt_N;
extern opt opt_s;
extern opt opt_x;
extern opt opt_o;
extern opt opt_S;
extern opt opt_t;
extern opt opt_T;
extern opt opt_F;
extern opt opt_ts;
extern opt opt_tr;
extern opt opt_tf;
extern opt opt_ta;
extern opt opt_d;
extern opt opt_sr;
extern opt opt_ss;

/* variables */
extern struct timeval fullstart, fullend; /* time for all connections */
extern struct timeval connstart, connend; /* time for full connection */
extern struct timeval sendstart, sendend; /* time for sending */
extern struct timeval readstart, readend; /* time for reading */

/* these cohere to their respective 'opt' variables */
extern struct timespec time_T;
extern struct timespec time_s;
extern struct timespec time_N;

extern char s_pid[40]; /* enough for a 128-bit pid */

/* define a sock_buf structure while we're referencing sockbuf */
extern struct sock_buf { int recv; int send; } sockbuf;

#endif
