#include <sys/time.h>
#include <unistd.h>
#include <string.h>
#include <errno.h>
#include <stdio.h>
#include "misc.h"

/* p_time()
 * print time difference (end - start)
 * uses str as a label, and optionally appends poststr
 */
void p_time (str, start, end, poststr)
	char *str;
	struct timeval *start;
	struct timeval *end;
	char *poststr;
{
	char timebuf[100]; /* enough for 2^128 twice, plus some extra chars */
	long seconds, micros;
	float timetotal;

	seconds = end->tv_sec - start->tv_sec;
	micros  = end->tv_usec - start->tv_usec;

	timetotal = (float) micros / 1000000;
	timetotal += seconds;

	/* we don't need snprintf here, and it's slower, dammit,
	 * so don't complain.
	 * sigh... i still don't like sprintf
	 */
	sprintf (timebuf, "%1.2f", timetotal);

	outlog (gdout, "real time for ", str, ": ", timebuf, poststr);
}

void ptime (str, start, end)
	char *str;
	struct timeval *start;
	struct timeval *end;
{
	p_time (str, start, end, 0);
}

/* print the time difference with an instance string */
void pntime (str, start, end, i)
	char *str;
	struct timeval *start;
	struct timeval *end;
	unsigned long i;
{
	lx_s ns = {0};

	if (lx_strset (&ns, " [instance ")) die_nomem();
	if (lx_straddulong (&ns, i, 10)) die_nomem();
	if (lx_stradd (&ns, "]")) die_nomem();
	if (lx_check0 (&ns)) die_nomem();
	p_time (str, start, end, ns.s);
	lx_free (&ns);
}
